/*  
 * gasket
 * forwarding enocode/decode tool
 *
 * experimental
 *
 * by rash <rashray@inbox.ru>, (c)m00 /www.m00security.org / m00.void.ru/ 
 */

#include <stdio.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/time.h>
#include <stdlib.h>
#include <netinet/in.h>
#include <string.h>

void usage()
{
  printf("\n gasket [-m mode] [-lt port] [-lp protocol] [-ls password]\n");
  printf("        [-rp protocol] [-rs password] <hostr>\n\n");
  printf("  -m     g/p. g-gasket, p-proxy; mode of operation\n");
  printf("         default: g\n");
  printf("  -lt    port used for acceptance of incoming connections\n");
  printf("         default: 11100\n");
  printf("  -lp    tcp/udp; protocol, which will be used for acceptance of\n"); 
  printf("         incoming connections\n");
  printf("         default: tcp\n");
  printf("  -ls    password requested at incoming connection\n");
  printf("         default: m00\n");
  printf("  -rp    tcp/udp; protocol, which will be used for the remote connection\n");
  printf("         default: tcp\n");
  printf("  -rs    password which will be used for the remote connection\n");
  printf("         default: m00\n");
  printf("  rhost  ip:port; ip adress:port, which will be used for the remote\n"); 
  printf("         connection\n\n");
  exit(0);
}


int main(int argc, char *argv[])
{ int lfd, afd, rfd, lport,
      mode,                  // 1-gasket, 0-proxy
      lproto,                // 1-tcp; 0-udp
      rproto;                // also
  char lpass[15], rpass[15],lrpass[15]; // local and remote passwords
  int len,sz,i,err;                             
  int code = 0x07;            
  struct sockaddr_in lsin, lrsin, rsin;
  fd_set fds, fder;
  char buf[2000];
  char raddr[22], rport[6];
  struct timeval tv;
  
  int clsock()
  {    
    close(rfd); if (lproto) shutdown(afd, SHUT_RDWR); 
  }
  
  
  bzero(raddr,22);
  bzero(rport,6);
  bzero(lpass,15); bzero(rpass,15);
  /* set default values */
  mode=lproto=rproto = 1;
  lport = 11100;
  strcpy(lpass,"m00");
  strcpy(rpass,"m00");   
  if (argc==1) usage();
  /* analysis of parameters */
  for (i=1;i<argc;i+=2) {
    switch (argv[i] [1])
    {
      case 'm':
            { 
	      mode=(strcmp(argv[i+1],"g"))?0:1;
            }
            break;
      case 'l':
           { switch (argv[i] [2]){
	        case 't':
                      { lport=atoi(argv[i+1]);} break;
	        case 'p': 
		      { lproto=(strcmp("tcp", argv[i+1]))?0:1;} break;
		case 's': 
		      { (strlen(argv[i+1])>14)?strncpy(lpass,argv[i+1],14):strcpy(lpass,argv[i+1]);
		      } break;
             }
           }        
           break;
      case 'r':
           { switch (argv[i] [2]){
	        case 'p':
		      { rproto=(strcmp("tcp", argv[i+1]))?0:1; break;}
		case 's':
		      { (strlen(argv[i+1])>14)?strncpy(rpass,argv[i+1],14):strcpy(rpass,argv[i+1]);
		      } break;
             }
           } break;
    } //switch
  }//for
  /* sorcery :) */
  if ( ((strchr(argv[argc-1],0x3a))==NULL) || (strlen(argv[argc-1])>21) ) usage();
  if (((i = ( (strchr(argv[argc-1],0x3a))-argv[argc-1]))>15) || (i<7) ) usage();;
  if ((sz = (strlen(argv[argc-1])-i-1))>5) usage();
  memcpy(raddr, argv[argc-1], i);
  memcpy(rport,(argv[argc-1]+i+1),sz);
  
  printf("Operation factors:\n");
  printf("mode: %d\nlport: %d\nlproto: %d\nlpass: %s\nrproto: %d\nrpass: %s\nrip: %s\nrport: %s\n", mode, lport, lproto, lpass, rproto, rpass, raddr, rport);
  /* clear parametrs */
  sz = 0;
  for(i=1; i<argc; sz+=strlen(argv[i]),i++);  
  memset(argv[1], '\0', sz+argc);
  
  daemon(0,0);
  
  /* prepare lsin lrsin rsin */
  lsin.sin_family      = AF_INET;
  lsin.sin_addr.s_addr = 0;
  lsin.sin_port        = htons(lport);
  
  rsin.sin_family      = AF_INET;
  rsin.sin_addr.s_addr = inet_addr(raddr);
  rsin.sin_port        = htons(atoi(rport));
  sz = sizeof(lrsin);
  
  if ((lfd = socket(AF_INET, (lproto)?1:2, (lproto)?6:17))<0){   
    perror("[-] socket(lfd)");
    exit(1);
  }   
  if ((bind(lfd, (struct sockaddr *)&lsin, sizeof(struct sockaddr)))!=0) {
    perror("[-] bind()");
    exit(1);
  }   
  if (lproto) listen(lfd,0);
  while(1){
    if (lproto) 
      if ((afd = accept(lfd,0,0))<0) {
        perror("[-] accept()"); 
        continue; //mm..
      }   
    memset(&lrsin, 0, sizeof(struct sockaddr));
    lrsin.sin_family = AF_INET;
    bzero(lrpass,15); 
    /* read password from client */
    if (lproto) len = read(afd, lrpass, 16);
    else len = recvfrom(lfd, lrpass, 16, 0, (struct sockaddr *)&lrsin, &sz);       
    if (len<0){      
      if(lproto) close(afd);
      continue;
    }
    /* compare passwords */
    if (lrpass[len-1] == '\n') lrpass[len-1] = '\0';    
    if (strcmp(lpass, lrpass)) { 
      if (lproto){
        write(afd, "-ER", 4); 
	close(afd);
      }else 
        len = sendto(lfd, "-ER", 4, 0, (struct sockaddr *)&lrsin, sz);
      continue;
    }  
    /* if authorization successfully */
    /* nado delat soedinenie na remote host 8) */
    if ((rfd = socket(AF_INET, (rproto)?1:2, (rproto)?6:17))<0){   
      perror("[-] socket(rfd)");
      exit(1);
    }
    if (rproto)
      if (connect(rfd,(struct sockaddr *) &rsin, sz)<0){  
        perror("[-] connect()");
        if (lproto){
          write(afd, "- connect()\n", 13); 
          close(afd);
        }else {
          sendto(lfd, "- connect()\n", 13, 0, (struct sockaddr *)&lrsin, sz);
	}
	continue;
      }   
    if (lproto) write(afd, "+ connect()\n", 13); 
      else len = sendto(lfd, "+ connect()\n", 13, 0, (struct sockaddr *)&lrsin, sz);
    /* sending remote pass */
    if (rproto) write(rfd, rpass, strlen(rpass));
      else len = sendto(rfd, rpass, strlen(rpass), 0, (struct sockaddr *)&rsin, sz);
    /* beginig obrabotky io() =) */
    afd = (lproto)?afd:lfd;
    while(1){
      FD_ZERO(&fds);
      FD_SET(afd, &fds);     
      FD_SET(rfd, &fds);
      FD_ZERO(&fder);
      FD_SET(afd, &fder);     
      FD_SET(rfd, &fder);
    
      tv.tv_sec = 0;
      tv.tv_usec = 0;    
     
      err = select ((afd>rfd)?(afd+1):(rfd+1), &fds, NULL, &fder, &tv);
      if (err < 0) {
        if (err == -4)
          continue;
        clsock();
	break;
      }
      
      if (FD_ISSET(afd,&fds)) {
        if (lproto) len = read(afd, buf, 2000);
          else len = recvfrom(afd, buf, 2000, 0, (struct sockaddr *)&lrsin, &sz);       
        printf("lrecv/rwrite()\n");
        if ((len <= 0) && (len != -4)){
          perror("[-] read/recvfrom(afd)");
          if (rproto) write(rfd, "exit\n", 7); 
            else len = sendto(rfd, "exit\n" ,7, 0, (struct sockaddr *)&rsin, sz);
	  clsock();
	  break;
        }
        if (mode)             /* if gasket */
	  for(i=0;i<len;i++)  /* encode */
            *(buf+i) ^= code ;
	//need send remote
        if (rproto) write(rfd, buf, len); 
          else len = sendto(rfd, buf, len, 0, (struct sockaddr *)&rsin, sz);
	if (len<0){
	 if (lproto) write(afd, "- write()\n", 11); 
           else len = sendto(afd, "- sendto()\n", 12, 0, (struct sockaddr *)&lrsin, sz);       	  
         clsock();
	 break; 
	}  
      }//if set afd
      
      if (FD_ISSET(rfd,&fds)) {
        if (rproto) len = read(rfd, buf, 2000);
          else len = recvfrom(rfd, buf, 2000, 0, (struct sockaddr *)&rsin, &sz);       
        printf("rrecv/lwrite()\n");
        if ((len <= 0) && (len != -4)){
          if (lproto) write(afd, "- read()\n", 10); 
            else len = sendto(afd, "- recvfrom()\n", 14, 0, (struct sockaddr *)&lrsin, sz);       	  
          clsock();
          break; 	  
        }
        if (mode)             /* if gasket */	
          for(i=0;i<len;i++)  /* decode */
            *(buf+i) ^= code ;
	//need send to client
        if (lproto) write(afd, buf, len); 
          else len = sendto(afd, buf, len, 0, (struct sockaddr *)&lrsin, sz);       	
	if (len<0){	 
          perror("[-] write/sendto(afd)");
	  if (rproto) write(rfd, "exit\n", 7); 
            else len = sendto(rfd, "exit\n" ,7, 0, (struct sockaddr *)&rsin, sz);
	  clsock();	  
          break; 
	}  
      } //if set rfd     
    }//second while  
  }//first while
}


