/*
 * m00-mysqlscan.c
 *
 * Tool for searching and auditing mysql servers.
 * Coded special for m00-mysqlfuxor.tar.gz
 * Private. Do not distro..
 *
 * ~m00.0x333.org
 *
*/

#include <string.h>
#include <unistd.h>
#include <netdb.h>
#include <stdio.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <netdb.h>
#include <fcntl.h>
#include "m00-mysqlscan-settings.h"

typedef struct  {
	int s;
	unsigned int state;
	unsigned int addr;
	unsigned int tmst;
} s_struct;

struct hostent *hp;
static s_struct *s;
static unsigned int count = COUNT;
unsigned int timeout = TIMEOUT;
char recvbuf[1024];
int ijk;

void usage(char *progname)
{
	printf("[~] Usage: %s <start_ip> <end_ip>\n\n",progname);
	exit(0);
}

int connect_to_host(unsigned int ip, unsigned short port) {

	int sockfd;

	struct hostent *hs;
	struct sockaddr_in sock;

	bzero(&sock, sizeof(sock));
	sock.sin_family = AF_INET;
	sock.sin_port   = htons(port);

	sock.sin_addr.s_addr = ip;


	if((sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0)
		return -1;

	if(connect(sockfd, (struct sockaddr *)&sock, sizeof(sock)) < 0)
		return -1;

	return sockfd;
}

void printf_f(char *msg,char *text) {
	printf(" # %s (uname: %s) => [%s]  \r",msg,USERNAME,text);
	fflush(stdout);
}

int vuln_check(unsigned int ip,char *auth_packet,int pktsize,char *msg) {
	char status[6];
	int sockfd;
	int stage=0;
	
	for(ijk=0;ijk<5;ijk++) status[ijk]='-';
	status[5]='\0';

	status[stage]='#';
	printf(" # %s => [%s]\r",msg,status);
	
	if((sockfd=connect_to_host(ip,DEFAULT_PORT))<1) {
		printf(" # oops, disconnected ?!?\n\n");
		return 0;
	}
	
	status[++stage]='#';
	printf_f(msg,status);
	
	if((recv(sockfd,recvbuf,1023,0))<0) {
		printf(" # oops, got disconnected ?!?\n\n");
		return 0;
	}
	
	status[++stage]='#';
	printf_f(msg,status);
	
	if((send(sockfd,auth_packet,pktsize,0))<0) {
		printf(" # oops, disconnected ?!?\n\n");
		return 0;
	}
	
	status[++stage]='#';
	printf_f(msg,status);
	
	if((recv(sockfd,recvbuf,1023,0))<0) {
		printf(" # oops, got disconnected ?!?\n\n");
		return 0;
	}
	
	status[++stage]='#';
	printf_f(msg,status);
	
	if(recvbuf[4]=='\x00' || recvbuf[4]=='\xfe')
		printf(" # %s (uname: %s) => YES        \n",msg,USERNAME);
	else
		printf(" # %s (uname: %s) => NO         \n",msg,USERNAME);
	fflush(stdout);

}

int scan(unsigned int start, unsigned int end, int port) {
	struct in_addr inaddr;
	struct sockaddr_in dst;
	struct timeval tv = {0,0};
	static unsigned int run = 0;
	static unsigned int i,j,k;
	static long on = 1;
	static long off = 0;
	unsigned int pause;
	unsigned int ex,any;
	unsigned int left;
	unsigned int *con;
	char ver_string[10];
	fd_set  fdset;

	if(start == -1) {
		printf(" - Bad <start_ip>.\n\n");
		exit(0);
	}
	if(end == -1) {
		printf(" - Bad <end_ip>.\n\n");
		exit(0);
	}

	s = (s_struct *)malloc(count*sizeof(s_struct));
	memset(s,0,count*sizeof(s_struct));

	FD_ZERO(&fdset);
	ex = 0;
	left = htonl(end)-htonl(start)+1;
	con = (unsigned int *) malloc(left*sizeof(unsigned int));
	memset(con,0,left*sizeof(unsigned int));

	memset(&dst,0,sizeof(dst));
	dst.sin_addr.s_addr = start;
	dst.sin_port = htons(port);
	dst.sin_family = AF_INET;
	run = 1;
	usleep(10);

	while(!ex) {
		for(i=0;(i<count) && left;i++) {
			if(s[i].state == CLSD)   {
				s[i].s = socket(AF_INET,SOCK_STREAM,0);
				if(s[i].s > 0) {
					fcntl(s[i].s,F_SETFL,O_NONBLOCK);
					s[i].state = READY;
				}
			}

			if(s[i].state == READY){
				connect(s[i].s,(struct sockaddr*)&dst,sizeof(dst));
				s[i].state = CNTG;
				s[i].addr = dst.sin_addr.s_addr;
				s[i].tmst = time(NULL);
				dst.sin_addr.s_addr=htonl(ntohl(dst.sin_addr.s_addr)+1);
				left--;
			}
		}

		FD_ZERO(&fdset);
		for(i=0;i<count;i++)
			if(s[i].state == CNTG)
				FD_SET(s[i].s,&fdset);
				select(FD_SETSIZE,NULL,&fdset,NULL,&tv);
				for(i=0;i<count;i++) {
					if(FD_ISSET(s[i].s,&fdset))  {
						fcntl(s[i].s,F_SETFL,O_RDWR);
						if (!(recv(s[i].s,recvbuf,5,0)<0)){
							inaddr.s_addr = s[i].addr;
							recv(s[i].s,recvbuf,1023,0);
							printf(" # %s:%d => OPENED\n",inet_ntoa(inaddr),port);
							printf(" # mysql => ");
							if(strstr(recvbuf,denied) || recvbuf[2]=='\x27' || strstr(recvbuf,"Host")) {
								printf("unknow\n");
								printf(" # accessable from your IP => NO\n\n");
							} else {
								memcpy(ver_string,recvbuf,7);
								if(isdigit(ver_string[6]))
									ver_string[7]='\0';
								else ver_string[6]='\0';
								printf("%s\n",ver_string);
								printf(" # accessable from your IP     => YES\n");
								printf(" # vulnerable to CAN-2003-0780 => ");
								
								ijk=0;
								while(CAN20030780[ijk])
									if(strstr(ver_string,CAN20030780[ijk])) {
										printf("YES\n",ijk);
										break;
									} else ijk++;
								if(!CAN20030780[ijk]) printf("NO\n");
								
								printf(" # vulnerable to CAN-2002-1375 => ");
								
								ijk=0;
								while(CAN20021375[ijk])
									if(strstr(ver_string,CAN20021375[ijk])) {
										printf("YES\n",ijk);
										break;
									} else ijk++;
								if(!CAN20021375[ijk]) printf("NO\n");

								vuln_check(s[i].addr,auth_packet_with_zero_len_pwd,sizeof(auth_packet_with_zero_len_pwd),"zero-length auth bypass");
								vuln_check(s[i].addr,auth_packet_without_password,sizeof(auth_packet_without_password),"without password access");
								
								printf("\n");
							}
						}
						close(s[i].s);
						s[i].state = CLSD;
					}
				}

			FD_ZERO(&fdset);
			for(i=0;i<count;i++) {
				if(s[i].state == CNTG) {
					if((time(NULL)-s[i].tmst)>timeout)    {
						fcntl(s[i].s,F_SETFL,O_RDWR);
						close(s[i].s);
						s[i].state = CLSD;
						inaddr.s_addr = s[i].addr;
					} else FD_SET(s[i].s,&fdset);
				}
			}

			select(FD_SETSIZE,NULL,NULL,&fdset,&tv);
			for(i=0;i<count;i++) {
				if(FD_ISSET(s[i].s,&fdset)) {
					fcntl(s[i].s,F_SETFL,O_RDWR);
					close(s[i].s);
					s[i].state = CLSD;
					inaddr.s_addr = s[i].addr;
				}
			}
			if (!left) {
				any=0;
				for (i=0;i<count;i++) {
					if (s[i].state != CLSD)  any=1;
						if (!any) ex = 1;
				}
			}
		usleep(pause*1000);
	} // while(!ex)

	printf(" # Scanning complete\n");
	exit(0);
}

int main(int argc, char *argv[]) {
	unsigned int start=0,end=0,verbose=0;
	int c;

	if(argc<3) usage(argv[0]);
	start = inet_addr(argv[1]);
	end = inet_addr(argv[2]);

	printf("\n # Scanning IP-range: %s - %s\n\n",argv[1],argv[2]);
	
	if(start && end) scan(start,end,DEFAULT_PORT); else usage(argv[0]);

	exit(0);
}
