/*  
  m00-np.02.c  -  No pasaran!
  Protection of your shell against scanning outside
  Give access to the indicated port only from indicated ip
  IMPORTANT: this don't give access to port, if this is 
  denied by firewall.
  
  try first:
  #gcc -c m00-np.02.c
  #gcc -c cleaner.c
  #./start
  
  try second:
  #gcc -c m00-np.02.c -I /usr/src/linux/include
  #gcc -c cleaner.c -I /usr/src/linux/include
  #./start
  
  tested: 2.4.3-20, 2.4.20-8;
  in 2.4.3 need comment 'MODULE_LICENSE("GPL");' line in here 
  and cleaner.c
   
  stuff for dudes, "for fun" :)
  by / rash / m00 / m00.void.ru /
  
  please, do not disributive it. Use it for youself, for fun.
    
*/

#define __KERNEL__
#define MODULE

#ifdef MODVERSIONS
#include <linux/modversions.h>
#endif

#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/version.h>
#include <linux/config.h>
#include <linux/skbuff.h>
#include <linux/ip.h>
#include <linux/tcp.h>
#include <linux/netfilter.h>
#include <linux/netfilter_ipv4.h>
#include <linux/netdevice.h>
#include <linux/if_arp.h>
#include <linux/if_ether.h>

#define	IP_DF 0x4000			/* dont fragment flag */
#define IPPROTO_TCP 6

static struct nf_hook_ops nfho;

/* Our ip addres*/
static unsigned char *our_ip = "\xC0\xA8\x00\x09"; // 192.168.0.9

/* Protected port */
static unsigned char *our_port = "\x00\x16"; // 22

MODULE_LICENSE("GPL");

unsigned long int m_htonl(unsigned long int val);
unsigned short int m_htons(unsigned short int val);
char *m_memcpy(char *dest, char *src, int size);


unsigned short tcp_checksum(unsigned long saddr, unsigned long daddr, int len, struct tcphdr *th)
{
  /* Nitr0gen, we remeber u ;] */
  static unsigned short in_cksum(unsigned short *addr, int len)
  {
    register int sum    = 0;
    u_short answer      = 0;
    register u_short *w = addr;
    register int nleft  = len;
    
    while (nleft > 1) {
      sum += *w++;
      nleft -= 2;
    }
   
    if (nleft == 1) {
      *(u_char *)(&answer) = *(u_char *)w;
      sum += answer;
    }
   
    sum = (sum >> 16) + (sum & 0xffff);
    sum += (sum >> 16);
    answer = ~sum;
    return(answer);
  }
  
  struct pseudohdr {
    unsigned long  saddr;
    unsigned long  daddr;
    unsigned char  reserved;
    unsigned char  proto;
    unsigned short len;
  } pseudohdr;
  char *pseudo;  
  unsigned short tcpsum;
    
    /* Pseudo header */
    pseudohdr.saddr    = saddr;
    pseudohdr.daddr    = daddr;
    pseudohdr.reserved = 0;
    pseudohdr.proto    = IPPROTO_TCP;
    pseudohdr.len      = m_htons(len);
    if ((pseudo = (char *) kmalloc(sizeof(struct pseudohdr)+len, GFP_KERNEL)) == NULL) {
      return 0;     
    }
    m_memcpy(pseudo, (char *)&pseudohdr, sizeof(struct pseudohdr));
    m_memcpy((pseudo + sizeof(struct pseudohdr)), (char *)th, len);
    tcpsum = in_cksum((unsigned short *)pseudo,(sizeof(struct pseudohdr)+len));     
    kfree(pseudo);
    return tcpsum;  
}



unsigned int hook_func(unsigned int hooknum,struct sk_buff **skb,const struct net_device *in,const struct net_device *out,int (*okfn) (struct sk_buff *))
{
  struct sk_buff *sb = *skb;
  struct iphdr *iph; 
  struct tcphdr *tcp; 
  unsigned int size;
  unsigned short int tport;
  int csum;  
  struct tcphdr *tcph;
  u_int16_t tmp_port;
  u_int32_t tmp_addr; 
  
  /* Protect youself from error*/
  if (!sb) return NF_ACCEPT;
  if (!(sb->nh.iph)) return NF_ACCEPT;
  
  /* Checking protocol */
  if (sb->nh.iph->protocol != IPPROTO_TCP ) return NF_ACCEPT;
  
  tcph = (struct tcphdr *)(sb->data+ (sb->nh.iph->ihl * 4));
  /* Checking port */
  if (tcph->dest != *(unsigned short *) our_port) return NF_ACCEPT;  
  /* Checking ip */
  if(sb->nh.iph->saddr != *(unsigned int *)our_ip) {

    /* No RST for RST. From kernel:) */
    if (tcph->rst)
 	return NF_ACCEPT;                

    sb->pkt_type = PACKET_OUTGOING;    
    
    switch (sb->dev->type) {
       case ARPHRD_PPP:
         break;
       case ARPHRD_LOOPBACK:
       case ARPHRD_ETHER:
            {
	      unsigned char t_hwaddr[ETH_ALEN];
	      sb->data = (unsigned char *)sb->mac.ethernet;
	      sb->len += ETH_HLEN;
	      memcpy(t_hwaddr, (sb->mac.ethernet->h_dest), ETH_ALEN);
	      memcpy((sb->mac.ethernet->h_dest),(sb->mac.ethernet->h_source), ETH_ALEN);
	      memcpy((sb->mac.ethernet->h_source),t_hwaddr, ETH_ALEN);
	      break;
	    }    
    } //switch     
    
    //change ports
    tmp_addr = sb->nh.iph->saddr;
    sb->nh.iph->saddr = sb->nh.iph->daddr;
    sb->nh.iph->daddr = tmp_addr;
    tmp_port = tcph->source;
    tcph->source = tcph->dest;
    tcph->dest = tmp_port;    
    
    /* Truncate to length (no data) */
    tcph->doff = sizeof(struct tcphdr)/4;
    //Don't ask me!! 8)
    skb_trim(sb, sb->nh.iph->ihl*4 + sizeof(struct tcphdr)+14);
    sb->nh.iph->tot_len = m_htons(sb->len-14);    

    tcph->ack_seq = m_htonl(m_htonl(tcph->seq)+1);
    tcph->seq = 0;
   
    /* Reset flags */
    ((u_int8_t *)tcph)[13] = 0;
    tcph->rst = 1;
    tcph->ack = 1;
    tcph->window = 0;
    tcph->urg_ptr = 0;

    /* Adjust TCP checksum */
    size = m_htons(sb->nh.iph->tot_len)-(sb->nh.iph->ihl*4);
    tcph->check = 0;        
    tcph->check = tcp_checksum(sb->nh.iph->saddr,sb->nh.iph->daddr, size, tcph);
    
    /* Adjust IP TTL, DF */
    sb->nh.iph->ttl = MAXTTL;
    /* Set DF, id = 0 */
    sb->nh.iph->frag_off = m_htons(IP_DF);
    sb->nh.iph->id = 0;
    
    /* Adjust IP checksum */
    sb->nh.iph->check = 0;	
    ip_send_check(sb->nh.iph);    
    
    sb->csum = 0;
    csum = csum_partial(sb->h.raw + tcph->doff, size - tcph->doff, 0);
    sb->csum = csum;        

    dev_queue_xmit(sb);
    
    return NF_STOLEN;  
  }else {
    return NF_ACCEPT;  
  }
}
 

int init_module()
{
  nfho.hook = hook_func;
  nfho.hooknum = NF_IP_PRE_ROUTING;
  nfho.pf = PF_INET;
  nfho.priority = NF_IP_PRI_FIRST;  
  nf_register_hook(&nfho);
    
  return 0;
}

void cleanup_module()
{
  nf_unregister_hook(&nfho);
}

// Hey! I not found sources this function. I write it self! ;]
unsigned long int m_htonl(unsigned long int val)
{
 unsigned long int tmp;
 
 tmp = val;
 tmp<<=24; 
 tmp |= (val<<8)&0x00ff0000;
 tmp |= (val>>8)&0x0000ff00;
 tmp |= val>>24;
 return tmp;
}

//It too :)
unsigned short int m_htons(unsigned short int val)
{
 unsigned short int tmp;
 
 tmp = val;
 val<<= 8; 
 tmp>>=8; 
 tmp |=val;
 return tmp;
}

//he-he, it's grabbed from phrack! kossak - hello
char *m_memcpy(char *dest, char *src, int size)
{
 char *i, *p;
 
 p = dest;
 i = src;
 
 while (size){
   *p = *i;
   i++;
   p++;
   size--;
 }
 return dest;
}
